Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 3633)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 3634)
@@ -4214,23 +4638,58 @@
              DO  k = nzb_max+1, nzt
 
-                u_comp(k) = u(k,j,i+1) + u(k,j,i)
-                flux_r(k) = ( u_comp(k) - gu ) * (                            &
+                u_comp = u(k,j,i+1) + u(k,j,i)
+                flux_r = ( u_comp - gu ) * (                                  &
                          37.0_wp * ( u(k,j,i+1) + u(k,j,i)   )                   &
                        -  8.0_wp * ( u(k,j,i+2) + u(k,j,i-1) )                   &
                        +           ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
-                diss_r(k) = - ABS( u_comp(k) - gu ) * (                       &
+                diss_r = - ABS( u_comp - gu ) * (                             &
                          10.0_wp * ( u(k,j,i+1) - u(k,j,i)   )                   &
                        -  5.0_wp * ( u(k,j,i+2) - u(k,j,i-1) )                   &
                        +           ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
 
-                v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                flux_n(k) = v_comp * (                                        &
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                u_comp_l = u(k,j,i) + u(k,j,i-1) - gu
+                flux_l   = u_comp_l * (                                       &
+                             37.0_wp * ( u(k,j,i) + u(k,j,i-1)   )                &
+                           -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )                &
+                           +           ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
+                diss_l   = - ABS(u_comp_l) * (                                &
+                             10.0_wp * ( u(k,j,i) - u(k,j,i-1)   )                &
+                           -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )                &
+                           +           ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
+#else
+                flux_l = swap_flux_x_local_u(k,j)
+                diss_l = swap_diss_x_local_u(k,j)
+#endif
+
+                v_comp = v(k,j+1,i) + v(k,j+1,i-1) - gv
+                flux_n = v_comp * (                                           &
                          37.0_wp * ( u(k,j+1,i) + u(k,j,i)   )                   &
                        -  8.0_wp * ( u(k,j+2,i) + u(k,j-1,i) )                   &
                        +           ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
-                diss_n(k) = - ABS( v_comp ) * (                               &
+                diss_n = - ABS( v_comp ) * (                                  &
                          10.0_wp * ( u(k,j+1,i) - u(k,j,i)   )                   &
                        -  5.0_wp * ( u(k,j+2,i) - u(k,j-1,i) )                   &
                        +           ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
+
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                v_comp_s = v(k,j,i) + v(k,j,i-1) - gv
+                flux_s   = v_comp_s * (                                       &
+                           37.0_wp * ( u(k,j,i) + u(k,j-1,i)   )                 &
+                         -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )                 &
+                         +           ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
+                diss_s   = - ABS( v_comp_s ) * (                              &
+                           10.0_wp * ( u(k,j,i) - u(k,j-1,i)   )                 &
+                         -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )                 &
+                         +           ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
+#else
+                flux_s = swap_flux_y_local_u(k)
+                diss_s = swap_diss_y_local_u(k)
+#endif
+
 !
 !--             k index has to be modified near bottom and top, else array
@@ -4244,6 +4703,6 @@
                 k_mm  = k - 2 * ibit17
 
-                w_comp    = w(k,j,i) + w(k,j,i-1)
-                flux_t(k) = w_comp * rho_air_zw(k) * (                       &
+                w_comp = w(k,j,i) + w(k,j,i-1)
+                flux_t = w_comp * rho_air_zw(k) * (                          &
                           ( 37.0_wp * ibit17 * adv_mom_5                        &
                        +     7.0_wp * ibit16 * adv_mom_3                        &
@@ -4260,5 +4719,5 @@
                                       )
 
-                diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (              &
+                diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                 &
                           ( 10.0_wp * ibit17 * adv_mom_5                        &
                        +     3.0_wp * ibit16 * adv_mom_3                        &
@@ -4278,5 +4737,5 @@
 !--             correction is needed to overcome numerical instabilities caused
 !--             by a not sufficient reduction of divergences near topography.
-                div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx &
+                div = ( ( u_comp      - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx &
                      +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy &
                      +  (   w_comp                      * rho_air_zw(k) -     &
@@ -4286,37 +4745,40 @@
 
                 tend(k,j,i) = tend(k,j,i) - (                                  &
-                 ( flux_r(k) + diss_r(k)                                       &
-               -   swap_flux_x_local_u(k,j) - swap_diss_x_local_u(k,j) ) * ddx &
-               + ( flux_n(k) + diss_n(k)                                       &
-               -   swap_flux_y_local_u(k)   - swap_diss_y_local_u(k)   ) * ddy &
-               + ( ( flux_t(k) + diss_t(k) )                                   &
-               -   ( flux_d    + diss_d    )                                   &
-                                                    ) * drho_air(k) * ddzw(k)  &
+                 ( ( flux_r + diss_r )                                         &
+               -   ( flux_l + diss_l ) ) * ddx                                 &
+               + ( ( flux_n + diss_n )                                         &
+               -   ( flux_s + diss_s ) ) * ddy                                 &
+               + ( ( flux_t + diss_t )                                         &
+               -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)               &
                                            ) + div * u(k,j,i)
 
-                swap_flux_x_local_u(k,j) = flux_r(k)
-                swap_diss_x_local_u(k,j) = diss_r(k)
-                swap_flux_y_local_u(k)   = flux_n(k)
-                swap_diss_y_local_u(k)   = diss_n(k)
-                flux_d                   = flux_t(k)
-                diss_d                   = diss_t(k)
+#ifndef _OPENACC
+                swap_flux_x_local_u(k,j) = flux_r
+                swap_diss_x_local_u(k,j) = diss_r
+                swap_flux_y_local_u(k)   = flux_n
+                swap_diss_y_local_u(k)   = diss_n
+#endif
+                flux_d                   = flux_t
+                diss_d                   = diss_t
 !
 !--             Statistical Evaluation of u'u'. The factor has to be applied
 !--             for right evaluation when gallilei_trans = .T. .
+                !$ACC ATOMIC
                 sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                      &
-                + ( flux_r(k)                                                  &
-                    * ( u_comp(k) - 2.0_wp * hom(k,1,1,0)                   )  &
-                    / ( u_comp(k) - gu + SIGN( 1.0E-20_wp, u_comp(k) - gu ) )  &
-                  + diss_r(k)                                                  &
-                    *   ABS( u_comp(k) - 2.0_wp * hom(k,1,1,0)              )  &
-                    / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp                  )  &
+                + ( flux_r                                                     &
+                    * ( u_comp - 2.0_wp * hom(k,1,1,0)                   )     &
+                    / ( u_comp - gu + SIGN( 1.0E-20_wp, u_comp - gu )    )     &
+                  + diss_r                                                     &
+                    *   ABS( u_comp - 2.0_wp * hom(k,1,1,0)              )     &
+                    / ( ABS( u_comp - gu ) + 1.0E-20_wp                  )     &
                   ) *   weight_substep(intermediate_timestep_count)
 !
 !--             Statistical Evaluation of w'u'.
+                !$ACC ATOMIC
                 sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                    &
-                + ( flux_t(k)                                                  &
+                + ( flux_t                                                     &
                     * ( w_comp - 2.0_wp * hom(k,1,3,0)                   )     &
                     / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              )     &
-                  + diss_t(k)                                                  &
+                  + diss_t                                                     &
                     *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              )     &
                     / ( ABS( w_comp ) + 1.0E-20_wp                       )     &
@@ -4369,7 +4831,17 @@
        REAL(wp)    ::  ibit19 !< flag indicating 3rd-order scheme along x-direction
        REAL(wp)    ::  ibit20 !< flag indicating 5th-order scheme along x-direction
+#ifdef _OPENACC
+       REAL(wp)    ::  ibit18_l !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit19_l !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit20_l !< flag indicating 5th-order scheme along x-direction
+#endif
        REAL(wp)    ::  ibit21 !< flag indicating 1st-order scheme along y-direction
        REAL(wp)    ::  ibit22 !< flag indicating 3rd-order scheme along y-direction
        REAL(wp)    ::  ibit23 !< flag indicating 5th-order scheme along y-direction
+#ifdef _OPENACC
+       REAL(wp)    ::  ibit21_s !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit22_s !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit23_s !< flag indicating 5th-order scheme along y-direction
+#endif
        REAL(wp)    ::  ibit24 !< flag indicating 1st-order scheme along z-direction
        REAL(wp)    ::  ibit25 !< flag indicating 3rd-order scheme along z-direction
@@ -4381,22 +4853,38 @@
        REAL(wp)    ::  gv     !< Galilei-transformation velocity along y
        REAL(wp)    ::  u_comp !< advection velocity along x
+#ifdef _OPENACC
+       REAL(wp)    ::  u_comp_l !< advection velocity along x
+#endif
        REAL(wp)    ::  w_comp !< advection velocity along z
        
+       REAL(wp)    ::  diss_s !< discretized artificial dissipation at southward-side of the grid box
+       REAL(wp)    ::  flux_s !< discretized 6th-order flux at southward-side of the grid box
+#ifndef _OPENACC
        REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_diss_y_local_v !< discretized artificial dissipation at southward-side of the grid box
        REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_flux_y_local_v !< discretized 6th-order flux at southward-side of the grid box
+#endif
        
+       REAL(wp)    ::  diss_l !< discretized artificial dissipation at leftward-side of the grid box
+       REAL(wp)    ::  flux_l !< discretized 6th-order flux at leftward-side of the grid box
+#ifndef _OPENACC
        REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local_v !< discretized artificial dissipation at leftward-side of the grid box
        REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local_v !< discretized 6th-order flux at leftward-side of the grid box
+#endif
        
-       REAL(wp), DIMENSION(nzb:nzt) ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  diss_t !< discretized artificial dissipation at top of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  flux_t !< discretized 6th-order flux at top of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  v_comp !< advection velocity along y
+       REAL(wp)    ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
+       REAL(wp)    ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
+       REAL(wp)    ::  diss_t !< discretized artificial dissipation at top of the grid box
+       REAL(wp)    ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
+       REAL(wp)    ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
+       REAL(wp)    ::  flux_t !< discretized 6th-order flux at top of the grid box
+       REAL(wp)    ::  v_comp !< advection velocity along y
+#ifdef _OPENACC
+       REAL(wp)    ::  v_comp_s !<
+#endif
 
        gu = 2.0_wp * u_gtrans
        gv = 2.0_wp * v_gtrans
+
+#ifndef _OPENACC
 !
 !--    First compute the whole left boundary of the processor domain
@@ -4457,7 +4945,26 @@
 
        ENDDO
-
+#endif
+
+       !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
+       !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
+       !$ACC PRIVATE(ibit18, ibit19, ibit20, ibit21, ibit22, ibit23) &
+       !$ACC PRIVATE(ibit18_l, ibit19_l, ibit20_l) &
+       !$ACC PRIVATE(ibit21_s, ibit22_s, ibit23_s) &
+       !$ACC PRIVATE(ibit24, ibit25, ibit26) &
+       !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
+       !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
+       !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
+       !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
+       !$ACC PRESENT(advc_flags_1) &
+       !$ACC PRESENT(u, v, w) &
+       !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
+       !$ACC PRESENT(tend) &
+       !$ACC PRESENT(hom(nzb+1:nzb_max,1,2:3,0)) &
+       !$ACC PRESENT(weight_substep(intermediate_timestep_count)) &
+       !$ACC PRESENT(sums_vs2_ws_l, sums_wsvs_ws_l)
        DO i = nxl, nxr
 
+#ifndef _OPENACC
           j = nysv
           DO  k = nzb+1, nzb_max
@@ -4467,6 +4974,6 @@
              ibit21 = REAL( IBITS(advc_flags_1(k,j-1,i),21,1), KIND = wp )
 
-             v_comp(k)              = v(k,j,i) + v(k,j-1,i) - gv
-             swap_flux_y_local_v(k) = v_comp(k) * (                           &
+             v_comp                 = v(k,j,i) + v(k,j-1,i) - gv
+             swap_flux_y_local_v(k) = v_comp * (                              &
                                    ( 37.0_wp * ibit23 * adv_mom_5                &
                                 +     7.0_wp * ibit22 * adv_mom_3                &
@@ -4483,5 +4990,5 @@
                                                  )
 
-             swap_diss_y_local_v(k) = - ABS( v_comp(k) ) * (                  &
+             swap_diss_y_local_v(k) = - ABS( v_comp ) * (                     &
                                    ( 10.0_wp * ibit23 * adv_mom_5                &
                                 +     3.0_wp * ibit22 * adv_mom_3                &
@@ -4502,10 +5009,10 @@
           DO  k = nzb_max+1, nzt
 
-             v_comp(k)              = v(k,j,i) + v(k,j-1,i) - gv
-             swap_flux_y_local_v(k) = v_comp(k) * (                           &
+             v_comp                 = v(k,j,i) + v(k,j-1,i) - gv
+             swap_flux_y_local_v(k) = v_comp * (                              &
                            37.0_wp * ( v(k,j,i) + v(k,j-1,i)   )                 &
                          -  8.0_wp * ( v(k,j+1,i) + v(k,j-2,i) )                 &
                          +           ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
-             swap_diss_y_local_v(k) = - ABS( v_comp(k) ) * (                  &
+             swap_diss_y_local_v(k) = - ABS( v_comp ) * (                     &
                            10.0_wp * ( v(k,j,i) - v(k,j-1,i)   )                 &
                          -  5.0_wp * ( v(k,j+1,i) - v(k,j-2,i) )                 &
@@ -4513,9 +5020,8 @@
 
           ENDDO
+#endif
 
           DO  j = nysv, nyn
 
-             flux_t(0) = 0.0_wp
-             diss_t(0) = 0.0_wp
              flux_d    = 0.0_wp
              diss_d    = 0.0_wp
@@ -4527,6 +5033,6 @@
                 ibit18 = REAL( IBITS(advc_flags_1(k,j,i),18,1), KIND = wp )
 
-                u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                flux_r(k) = u_comp * (                                       &
+                u_comp = u(k,j-1,i+1) + u(k,j,i+1) - gu
+                flux_r = u_comp * (                                          &
                           ( 37.0_wp * ibit20 * adv_mom_5                        &
                        +     7.0_wp * ibit19 * adv_mom_3                        &
@@ -4543,5 +5049,5 @@
                                      )
 
-                diss_r(k) = - ABS( u_comp ) * (                              &
+                diss_r = - ABS( u_comp ) * (                                 &
                           ( 10.0_wp * ibit20 * adv_mom_5                        &
                        +     3.0_wp * ibit19 * adv_mom_3                        &
@@ -4558,10 +5064,52 @@
                                               )
 
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                ibit20_l = REAL( IBITS(advc_flags_1(k,j,i-1),20,1), KIND = wp )
+                ibit19_l = REAL( IBITS(advc_flags_1(k,j,i-1),19,1), KIND = wp )
+                ibit18_l = REAL( IBITS(advc_flags_1(k,j,i-1),18,1), KIND = wp )
+
+                u_comp_l  = u(k,j-1,i) + u(k,j,i) - gu
+                flux_l    = u_comp_l * (                                     &
+                                      ( 37.0_wp * ibit20_l * adv_mom_5          &
+                                   +     7.0_wp * ibit19_l * adv_mom_3          &
+                                   +              ibit18_l * adv_mom_1          &
+                                      ) *                                    &
+                                     ( v(k,j,i)   + v(k,j,i-1) )             &
+                               -      (  8.0_wp * ibit20_l * adv_mom_5          &
+                                   +              ibit19_l * adv_mom_3          &
+                                      ) *                                    &
+                                     ( v(k,j,i+1) + v(k,j,i-2) )             &
+                               +      (           ibit20_l * adv_mom_5          &
+                                      ) *                                    &
+                                     ( v(k,j,i+2) + v(k,j,i-3) )             &
+                                                 )
+
+                 diss_l   = - ABS( u_comp_l ) * (                            &
+                                      ( 10.0_wp * ibit20_l * adv_mom_5          &
+                                   +     3.0_wp * ibit19_l * adv_mom_3          &
+                                   +              ibit18_l * adv_mom_1          &
+                                      ) *                                    &
+                                     ( v(k,j,i)   - v(k,j,i-1) )             &
+                               -      (  5.0_wp * ibit20_l * adv_mom_5          &
+                                   +              ibit19_l * adv_mom_3          &
+                                      ) *                                    &
+                                     ( v(k,j,i+1) - v(k,j,i-2) )             &
+                               +      (           ibit20_l * adv_mom_5          &
+                                      ) *                                    &
+                                     ( v(k,j,i+2) - v(k,j,i-3) )             &
+                                                           )
+#else
+                flux_l = swap_flux_x_local_v(k,j)
+                diss_l = swap_diss_x_local_v(k,j)
+#endif
+
                 ibit23 = REAL( IBITS(advc_flags_1(k,j,i),23,1), KIND = wp )
                 ibit22 = REAL( IBITS(advc_flags_1(k,j,i),22,1), KIND = wp )
                 ibit21 = REAL( IBITS(advc_flags_1(k,j,i),21,1), KIND = wp )
 
-                v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                flux_n(k) = ( v_comp(k) - gv ) * (                           &
+                v_comp = v(k,j+1,i) + v(k,j,i)
+                flux_n = ( v_comp - gv ) * (                                 &
                           ( 37.0_wp * ibit23 * adv_mom_5                        &
                        +     7.0_wp * ibit22 * adv_mom_3                        &
@@ -4578,5 +5126,5 @@
                                      )
 
-                diss_n(k) = - ABS( v_comp(k) - gv ) * (                      &
+                diss_n = - ABS( v_comp - gv ) * (                            &
                           ( 10.0_wp * ibit23 * adv_mom_5                        &
                        +     3.0_wp * ibit22 * adv_mom_3                        &
@@ -4592,4 +5140,47 @@
                                  ( v(k,j+3,i) - v(k,j-2,i) )                 &
                                                       )
+
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                ibit23_s = REAL( IBITS(advc_flags_1(k,j-1,i),23,1), KIND = wp )
+                ibit22_s = REAL( IBITS(advc_flags_1(k,j-1,i),22,1), KIND = wp )
+                ibit21_s = REAL( IBITS(advc_flags_1(k,j-1,i),21,1), KIND = wp )
+
+                v_comp_s = v(k,j,i) + v(k,j-1,i) - gv
+                flux_s   = v_comp_s * (                                      &
+                                   ( 37.0_wp * ibit23_s * adv_mom_5             &
+                                +     7.0_wp * ibit22_s * adv_mom_3             &
+                                +              ibit21_s * adv_mom_1             &
+                                   ) *                                       &
+                                     ( v(k,j,i)   + v(k,j-1,i) )             &
+                            -      (  8.0_wp * ibit23_s * adv_mom_5             &
+                                +              ibit22_s * adv_mom_3             &
+                                   ) *                                       &
+                                     ( v(k,j+1,i) + v(k,j-2,i) )             &
+                            +      (           ibit23_s * adv_mom_5             &
+                                   ) *                                       &
+                                     ( v(k,j+2,i) + v(k,j-3,i) )             &
+                                                 )
+
+                diss_s   = - ABS( v_comp_s ) * (                             &
+                                   ( 10.0_wp * ibit23_s * adv_mom_5             &
+                                +     3.0_wp * ibit22_s * adv_mom_3             &
+                                +              ibit21_s * adv_mom_1             &
+                                   ) *                                       &
+                                     ( v(k,j,i)   - v(k,j-1,i) )             &
+                            -      (  5.0_wp * ibit23_s * adv_mom_5             &
+                                +              ibit22_s * adv_mom_3             &
+                                   ) *                                       &
+                                     ( v(k,j+1,i) - v(k,j-2,i) )             &
+                            +      (           ibit23_s * adv_mom_5             &
+                                   ) *                                       &
+                                     ( v(k,j+2,i) - v(k,j-3,i) )             &
+                                                          )
+#else
+               flux_s = swap_flux_y_local_v(k)
+               diss_s = swap_diss_y_local_v(k)
+#endif
+
 !
 !--             k index has to be modified near bottom and top, else array
@@ -4603,6 +5194,6 @@
                 k_mm  = k - 2 * ibit26
 
-                w_comp    = w(k,j-1,i) + w(k,j,i)
-                flux_t(k) = w_comp * rho_air_zw(k) * (                       &
+                w_comp = w(k,j-1,i) + w(k,j,i)
+                flux_t = w_comp * rho_air_zw(k) * (                          &
                           ( 37.0_wp * ibit26 * adv_mom_5                        &
                        +     7.0_wp * ibit25 * adv_mom_3                        &
@@ -4619,5 +5210,5 @@
                                       )
 
-                diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (              &
+                diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                 &
                           ( 10.0_wp * ibit26 * adv_mom_5                        &
                        +     3.0_wp * ibit25 * adv_mom_3                        &
@@ -4646,5 +5237,5 @@
                                          )                                    &
                   ) * ddx                                                     &
-               +  ( v_comp(k)                                                 &
+               +  ( v_comp                                                    &
                                        * ( ibit21 + ibit22 + ibit23 )         &
                 - ( v(k,j,i)     + v(k,j-1,i) )                               &
@@ -4668,40 +5259,41 @@
 
                 tend(k,j,i) = tend(k,j,i) - (                                 &
-                       ( flux_r(k) + diss_r(k)                                &
-                     -   swap_flux_x_local_v(k,j) - swap_diss_x_local_v(k,j)  &
-                       ) * ddx                                                &
-                     + ( flux_n(k) + diss_n(k)                                &
-                     -   swap_flux_y_local_v(k) - swap_diss_y_local_v(k)      &
-                       ) * ddy                                                &
-                     + ( ( flux_t(k) + diss_t(k) )                            &
-                     -   ( flux_d    + diss_d    )                            &
-                       ) * drho_air(k) * ddzw(k)                              &
+                       ( ( flux_r + diss_r )                                  &
+                     -   ( flux_l + diss_l ) ) * ddx                          &
+                     + ( ( flux_n + diss_n )                                  &
+                     -   ( flux_s + diss_s ) ) * ddy                          &
+                     + ( ( flux_t + diss_t )                                  &
+                     -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)        &
                                             )  + v(k,j,i) * div
 
-                swap_flux_x_local_v(k,j) = flux_r(k)
-                swap_diss_x_local_v(k,j) = diss_r(k)
-                swap_flux_y_local_v(k)   = flux_n(k)
-                swap_diss_y_local_v(k)   = diss_n(k)
-                flux_d                   = flux_t(k)
-                diss_d                   = diss_t(k)
+#ifndef _OPENACC
+                swap_flux_x_local_v(k,j) = flux_r
+                swap_diss_x_local_v(k,j) = diss_r
+                swap_flux_y_local_v(k)   = flux_n
+                swap_diss_y_local_v(k)   = diss_n
+#endif
+                flux_d                   = flux_t
+                diss_d                   = diss_t
 
 !
 !--             Statistical Evaluation of v'v'. The factor has to be applied
 !--             for right evaluation when gallilei_trans = .T. .
+                !$ACC ATOMIC
                 sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                      &
-                + ( flux_n(k)                                                  &
-                    * ( v_comp(k) - 2.0_wp * hom(k,1,2,0)                   )  &
-                    / ( v_comp(k) - gv + SIGN( 1.0E-20_wp, v_comp(k) - gv ) )  &
-               +   diss_n(k)                                                   &
-                    *   ABS( v_comp(k) - 2.0_wp * hom(k,1,2,0)              )  &
-                    / ( ABS( v_comp(k) - gv ) + 1.0E-20_wp                  )  &
+                + ( flux_n                                                     &
+                    * ( v_comp - 2.0_wp * hom(k,1,2,0)                   )     &
+                    / ( v_comp - gv + SIGN( 1.0E-20_wp, v_comp - gv )    )     &
+               +   diss_n                                                      &
+                    *   ABS( v_comp - 2.0_wp * hom(k,1,2,0)              )     &
+                    / ( ABS( v_comp - gv ) + 1.0E-20_wp                  )     &
                   ) *   weight_substep(intermediate_timestep_count)
 !
 !--             Statistical Evaluation of w'u'.
+                !$ACC ATOMIC
                 sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                    &
-                + ( flux_t(k)                                                  &
+                + ( flux_t                                                     &
                     * ( w_comp - 2.0_wp * hom(k,1,3,0)                   )     &
                     / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              )     &
-               +   diss_t(k)                                                   &
+               +   diss_t                                                      &
                     *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              )     &
                     / ( ABS( w_comp ) + 1.0E-20_wp                       )     &
